﻿# fuelle-tiefensuche.py
# rekursives Programm zum Füllen eines Containers mit Tiefensuche
# (Rucksackproblem)
# Diese Variante ist natürlich schon optimiert, da die Rekursion
# abgebrochen wird, sobald der Container zu voll wird.
# Im Vergleich mit der entsprechenden Lösung mit Scheme
# ist wichtig, dass Python ebenfalls Rückgabewerte in
# Bedingungen akzeptiert, die nicht True oder False sind.
# Weiterhin ist wichtig, dass bei den rekursiven Aufrufen
# die Objekte neu angelegt werden und so nicht die Werte
# der aufrufenden Rekursionsstufe verändert werden.


# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20,20]

# Prädikat zum Testen, ob der Container voll ist.
def istVoll(container, fassungsvermoegen):
    return fassungsvermoegen==sum(container)

def istZuVoll(container, fassungsvermoegen):
    return fassungsvermoegen<sum(container)


def fuelle(stuecke, container, fassungsvermoegen):
    if istVoll(container, fassungsvermoegen):
        return container
    elif len(stuecke)==0:
        return False
    elif istZuVoll(container, fassungsvermoegen):
        return False
    else:
        ergebnis=fuelle(stuecke[1:], container+stuecke[:1], fassungsvermoegen)
        if ergebnis:
            return ergebnis
        else:
            return fuelle(stuecke[1:], container, fassungsvermoegen)

### Tests
def ausgabe(stuecke, fassungsvermoegen):
    print('Stücke:', stuecke, fassungsvermoegen,
          'Ergebnis:\n', fuelle(stuecke, [], fassungsvermoegen), '\n')


ausgabe( stuecke, 80)
ausgabe( stuecke, 90)
ausgabe( stuecke, 100)
ausgabe( stuecke*10, 100)
ausgabe( stuecke*10, 1000)
ausgabe( [30,30,20,20], 50)
