﻿# fuelle-zwei-tiefensuche-tiefe-liste.py
# Programm zum Füllen von Containern mit Tiefensuche
# (Rucksackproblem)

# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20,20]
def erzeuge_Container(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelle_ein(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

### Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])
### ... mit dem Stück zu voll wird.
def wird_zu_voll(stueck, container):
    return container[0]<stueck+sum(container[1])


def fuelle(stuecke, container_1, container_2):
    ##input(str((stuecke,container_1, container_2))) # verfolgen
    ##print(stuecke, container_1, container_2)
    if ist_voll(container_1) & ist_voll(container_2):
        return container_1, container_2
    if len(stuecke)==0:
        return False
    # Zunächst mit dem Stück im ersten versuchen - wenn es geht
    if not(wird_zu_voll(stuecke[0], container_1)):
        ##print('ersten versuchen')
        ergebnis=fuelle(stuecke[1:],
                        fuelle_ein(stuecke[0],container_1),
                        container_2)
        if ergebnis: return ergebnis
    # Dann mit dem Stück im zweiten versuchen - wenn es geht
    if not(wird_zu_voll(stuecke[0], container_2)):
        ##print('zweiten versuchen')
        ergebnis=fuelle(stuecke[1:],
                        container_1,
                        fuelle_ein(stuecke[0],container_2))
        if ergebnis: return ergebnis
    # In jedem Fall auch ohne das Stück versuchen:
    ##print('ohne das Stück versuchen')
    ergebnis=fuelle(stuecke[1:], container_1, container_2)
    if ergebnis: return ergebnis
    return False

### Tests:
def ausgabe(stuecke, c1, c2):
    print('Stücke:', stuecke, c1[0], c2[0],
          'Ergebnis:\n', fuelle(stuecke, c1, c2), '\n')

ausgabe( [30,30,20,20], erzeuge_Container(50),erzeuge_Container(50) )
ausgabe( stuecke, erzeuge_Container(80),erzeuge_Container(80) )
ausgabe( [30,30,30,30], erzeuge_Container(100),erzeuge_Container(100) )
ausgabe( [30,30,30,30,20,20], erzeuge_Container(90),erzeuge_Container(90) )
ausgabe( [30,30,30,30,20,20,20], erzeuge_Container(90),erzeuge_Container(90) )
ausgabe( stuecke, erzeuge_Container(90),erzeuge_Container(90) )
ausgabe( stuecke, erzeuge_Container(100),erzeuge_Container(100) )
